.data

# Strings for putint
intpattern:
        .string "0x12341234\n"
hexdigits:
        .string "0123456789abcdef"

.text

putint:
.global putint
        pushq %rbp
        movq %rsp, %rbp

        # Pour chaque demi-octet nous allons remplir le chiffre hexa
        # correspondant dans la chaine intpattern.
        # Le registre r13 servira à compter huit itérations.
        # Le registre r12 pointera vers la position courante dans intpattern;
        # on commence au 10ème caractère (intpattern+9) et on descend jusqu'au
        # 2ème..
        # Le registre edi contient l'entier à afficher; ses bits seront
        # décalés vers la droite au fur et à mesure de la conversion.
        movq $intpattern, %r12
        addq $9, %r12
        movq $0, %r13

l3:
        # On récupère le caractère *(hexdigits+al)
        movzbq %dil, %r11
        andq $0xf, %r11
        addq $hexdigits, %r11
        movb (%r11), %r11b
        movb %r11b, (%r12)
        addq $-1, %r12
        shrl $4, %edi
        # Préparation de l'étape suivante
        addq $1, %r13
        cmpq $8, %r13
        jne l3

        # Fin de la boucle, on affiche inpattern
        movq $11, %rdx
		movq $intpattern, %rsi
		movq $1, %rdi
		call write

        leave
        ret
